# Data Sources

## Coverage By Package Manager

- **deb** - grype, trivy ([see operating system distros](os-distro.md) for important information)
- **gem** - gemnasium, trivy, grype, oss-index (tested but got no results using a small bom)
- **golang**  - gemnasium, trivy, grype, oss-index  (have only seen results from trivy / oss-index)
- **maven** - gemnasium, trivy, grype, oss-index (confirmed results from all 4)
- **npm** - gemnasium, trivy, grype, oss-index (confirmed results from all 4)
- **nuget** - gemnasium, trivy, oss-index, grype ( no testing)
- **pypi** - gemnasium, trivy, grype, oss-index (confirmed results from all 4)
- **rpm** - grype,trivy, oss-index (oss-index coverage seems quite poor)([see operating system distros](os-distro.md) for important information)

## Gemnasium Data Sources

As a note, the official gemnasium database has terms of service that say it can't be used in 3rd party tools without explicit permission.
The community datasource is essentially the same it is just 30 days delayed.

### Tracking external sources

One of the main challenges of maintaining a vulnerability database
is to learn about security advisories recently published.
To that goal, the GitLab team checks external sources on a regular basis.
If an external source lists an advisory that is not already in gemnasium-db,
they research and check the advisory, add metadata to it, and publish it to this repo
following the contribution guidelines.

### Tracking process and schedule

Data-sources we check for updates on a daily basis:

- NVD JSON feeds
- GitHub security advisory database by means of the Trivy Advisory Database
- Ruby Advisory DB

Data-sources from which we sourced data in the past. Those data-sources are checked occasionally:

- FriendsOfPHP security advisories
- Victims CVE DB
- oss-security mailing list

While the advisory tracking for NVD and ruby-advisory-db is semi-automated,
we check the oss-security mailing list manually.
For the manual source tracking, we use the following strategy:

1. Look for vulnerability announcement that do not have a CVE with an announcement day not older than 4 weeks
2. Generate an identifier (as explained in our contribution guidelines)
3. Create an MR (according to our contribution guidelines)

:::note

It's preferred to create merge requests right away but the team member
in charge of checking the source may not be immediately available to do that,
and creating issues is a way to delay the task or to pass it on to another team member.

:::

## Grype Data Sources

- Alpine Linux SecDB: <https://secdb.alpinelinux.org/>
- Amazon Linux ALAS: <https://alas.aws.amazon.com/AL2/alas.rss>
- RedHat RHSAs: <https://www.redhat.com/security/data/oval/>
- Debian Linux CVE Tracker: <https://security-tracker.debian.org/tracker/data/json>
- Github GHSAs: <https://github.com/advisories>
- National Vulnerability Database (NVD): <https://nvd.nist.gov/vuln/data-feeds>
- Oracle Linux OVAL: <https://linux.oracle.com/security/oval/>
- RedHat Linux Security Data: <https://access.redhat.com/hydra/rest/securitydata/>
- Suse Linux OVAL: <https://ftp.suse.com/pub/projects/security/oval/>
- Ubuntu Linux Security: <https://people.canonical.com/~ubuntu-security/>

## Trivy Data Sources

### Trivy Data Sources by OS

:::note

The OS datasources do not seem to work with SBOM integration we should open an issue with trivy to address.

:::

| OS                 | Source                                      |
|--------------------|---------------------------------------------|
| Arch Linux         | [Vulnerable Issues][arch]                   |
| Alpine Linux       | [secdb][alpine]                             |
| Amazon Linux       | [Amazon Linux Security Center][amazon]      |
| Debian             | [Security Bug Tracker][debian-tracker]      |
|                    | [OVAL][debian-oval]                         |
| Ubuntu             | [Ubuntu CVE Tracker][ubuntu]                |
| RHEL/CentOS        | [OVAL][rhel-oval]                           |
|                    | [Security Data][rhel-api]                   |
| AlmaLinux          | [AlmaLinux Product Errata][alma]            |
| Rocky Linux        | [Rocky Linux UpdateInfo][rocky]             |
| Oracle Linux       | [OVAL][oracle]                              |
| CBL-Mariner        | [OVAL][mariner]                             |
| OpenSUSE/SLES      | [CVRF][suse]                                |
| Photon OS          | [Photon Security Advisory][photon]          |

### Trivy Data Sources by Programming Language

| Language                     | Source                                              | Commercial Use  | Delay[^1]|
| ---------------------------- | ----------------------------------------------------|:---------------:|:--------:|
| PHP                          | [PHP Security Advisories Database][php]             | ✅              | -        |
|                              | [GitHub Advisory Database (Composer)][php-ghsa]     | ✅              | -        |
| Python                       | [GitHub Advisory Database (pip)][python-ghsa]       | ✅              | -        |
|                              | [Open Source Vulnerabilities (PyPI)][python-osv]    | ✅              | -        |
| Ruby                         | [Ruby Advisory Database][ruby]                      | ✅              | -        |
|                              | [GitHub Advisory Database (RubyGems)][ruby-ghsa]    | ✅              | -        |
| Node.js                      | [Ecosystem Security Working Group][nodejs]          | ✅              | -        |
|                              | [GitHub Advisory Database (npm)][nodejs-ghsa]       | ✅              | -        |
| Java                         | [GitLab Advisories Community][gitlab]               | ✅              | 1 month  |
|                              | [GitHub Advisory Database (Maven)][java-ghsa]       | ✅              | -        |
| Go                           | [GitLab Advisories Community][gitlab]               | ✅              | 1 month  |
|                              | [The Go Vulnerability Database][go]                 | ✅              | -        |
| Rust                         | [Open Source Vulnerabilities (crates.io)][rust-osv] | ✅              | -        |
| .NET                         | [GitHub Advisory Database (NuGet)][dotnet-ghsa]     | ✅              | -        |

[^1]: Intentional delay between vulnerability disclosure and registration in the DB

#### Other Trivy Data Sources

| Name                            | Source     |
| --------------------------------|------------|
| National Vulnerability Database | [NVD][nvd] |

#### Data source selection

Trivy **only** consumes security advisories from the sources in the tables mentioned above.

As for packages installed from OS package managers (`dpkg`, `yum`, `apk`, etc.), Trivy uses the advisory database from the appropriate **OS vendor**.

For example: for a python package installed from `yum` (Amazon linux), Trivy will only get advisories from ALAS. But for a python package installed from another source (e.g. `pip`), Trivy will get advisories from the `GitLab` and `GitHub` databases.

This advisory selection is essential to avoid getting false positives because OS vendors usually backport upstream fixes, and the fixed version can be different from the upstream fixed version.
The severity is from the selected data source. If the data source does not provide severity, it falls back to NVD, and if NVD does not have severity, it will be UNKNOWN.

[arch]: https://security.archlinux.org/
[alpine]: https://secdb.alpinelinux.org/
[amazon]: https://alas.aws.amazon.com/
[debian-tracker]: https://security-tracker.debian.org/tracker/
[debian-oval]: https://www.debian.org/security/oval/
[ubuntu]: https://ubuntu.com/security/cve
[rhel-oval]: https://www.redhat.com/security/data/oval/v2/
[rhel-api]: https://www.redhat.com/security/data/metrics/
[alma]: https://errata.almalinux.org/
[rocky]: https://download.rockylinux.org/pub/rocky/
[oracle]: https://linux.oracle.com/security/oval/
[suse]: http://ftp.suse.com/pub/projects/security/cvrf/
[photon]: https://packages.vmware.com/photon/photon_cve_metadata/
[mariner]: https://github.com/microsoft/CBL-MarinerVulnerabilityData/

[php-ghsa]: https://github.com/advisories?query=ecosystem%3Acomposer
[python-ghsa]: https://github.com/advisories?query=ecosystem%3Apip
[ruby-ghsa]: https://github.com/advisories?query=ecosystem%3Arubygems
[nodejs-ghsa]: https://github.com/advisories?query=ecosystem%3Anpm
[java-ghsa]: https://github.com/advisories?query=ecosystem%3Amaven
[dotnet-ghsa]: https://github.com/advisories?query=ecosystem%3Anuget

[php]: https://github.com/FriendsOfPHP/security-advisories
[ruby]: https://github.com/rubysec/ruby-advisory-db
[nodejs]: https://github.com/nodejs/security-wg
[gitlab]: https://gitlab.com/gitlab-org/advisories-community
[go]: https://github.com/golang/vulndb

[python-osv]: https://osv.dev/list?q=&ecosystem=PyPI
[rust-osv]: https://osv.dev/list?q=&ecosystem=crates.io

[nvd]: https://nvd.nist.gov/
